Colt 1.2.0

## cern.colt.map
Class AbstractIntDoubleMap

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.map.AbstractMap
              cern.colt.map.AbstractIntDoubleMap

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  OpenIntDoubleHashMap

public abstract class AbstractIntDoubleMap
extends AbstractMap

Abstract base class for hash maps holding (key,value) associations of type `(int-->double)`. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Almost all methods are expressed in terms of `forEachKey(IntProcedure)`. As such they are fully functional, but inefficient. Override them in subclasses if necessary.

Version:
  1.0, 09/24/99
See Also:
  `HashMap`, Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Method Summary
`void` | `assign(AbstractIntDoubleMap other)` Clears the receiver, then adds all (key,value) pairs of `other`values to it.
`void` | `assign(DoubleFunction function)` Assigns the result of a function to each value; `v[i] = function(v[i])`.
`boolean` | `containsKey(int key)` Returns `true` if the receiver contains the specified key.
`boolean` | `containsValue(double value)` Returns `true` if the receiver contains the specified value.
`AbstractIntDoubleMap` | `copy()` Returns a deep copy of the receiver; uses `clone()` and casts the result.
`boolean` | `equals(Object obj)` Compares the specified object with this map for equality.
`abstract boolean` | `forEachKey(IntProcedure procedure)` Applies a procedure to each key of the receiver, if any.
`boolean` | `forEachPair(IntDoubleProcedure procedure)` Applies a procedure to each (key,value) pair of the receiver, if any.
`abstract double` | `get(int key)` Returns the value associated with the specified key.
`int` | `keyOf(double value)` Returns the first key the given value is associated with.
`IntArrayList` | `keys()` Returns a list filled with all keys contained in the receiver.
`void` | `keys(IntArrayList list)` Fills all keys contained in the receiver into the specified list.
`void` | `keysSortedByValue(IntArrayList keyList)` Fills all keys sorted ascending by their associated value into the specified list.
`void` | `pairsMatching(IntDoubleProcedure condition, IntArrayList keyList, DoubleArrayList valueList)` Fills all pairs satisfying a given condition into the specified lists.
`void` | `pairsSortedByKey(IntArrayList keyList, DoubleArrayList valueList)` Fills all keys and values sorted ascending by key into the specified lists.
`void` | `pairsSortedByValue(IntArrayList keyList, DoubleArrayList valueList)` Fills all keys and values sorted ascending by value into the specified lists.
`abstract boolean` | `put(int key, double value)` Associates the given key with the given value.
`abstract boolean` | `removeKey(int key)` Removes the given key with its associated element from the receiver, if present.
`String` | `toString()` Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by key.
`String` | `toStringByValue()` Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by value.
`DoubleArrayList` | `values()` Returns a list filled with all values contained in the receiver.
`void` | `values(DoubleArrayList list)` Fills all values contained in the receiver into the specified list.

Methods inherited from class cern.colt.map.AbstractMap
`clear, ensureCapacity, isEmpty, size, trimToSize`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### assign

    public void assign(DoubleFunction function)

  Assigns the result of a function to each value; `v[i] = function(v[i])`.

  Parameters:
    `function` - a function object taking as argument the current association's value.

### assign

    public void assign(AbstractIntDoubleMap other)

  Clears the receiver, then adds all (key,value) pairs of `other`values to it.

  Parameters:
    `other` - the other map to be copied into the receiver.

### containsKey

    public boolean containsKey(int key)

  Returns `true` if the receiver contains the specified key.

  Returns:
    `true` if the receiver contains the specified key.

### containsValue

    public boolean containsValue(double value)

  Returns `true` if the receiver contains the specified value.

  Returns:
    `true` if the receiver contains the specified value.

### copy

    public AbstractIntDoubleMap copy()

  Returns a deep copy of the receiver; uses `clone()` and casts the result.

  Returns:
    a deep copy of the receiver.

### equals

    public boolean equals(Object obj)

  Compares the specified object with this map for equality. Returns `true` if the given object is also a map and the two maps represent the same mappings. More formally, two maps `m1` and `m2` represent the same mappings iff

       m1.forEachPair(
      		new IntDoubleProcedure() {
      			public boolean apply(int key, double value) {
      				return m2.containsKey(key) && m2.get(key) == value;
      			}
      		}
      	)
       &&
       m2.forEachPair(
      		new IntDoubleProcedure() {
      			public boolean apply(int key, double value) {
      				return m1.containsKey(key) && m1.get(key) == value;
      			}
      		}
      	);

  This implementation first checks if the specified object is this map; if so it returns `true`. Then, it checks if the specified object is a map whose size is identical to the size of this set; if not, it it returns `false`. If so, it applies the iteration as described above.

  Parameters:
    `obj` - object to be compared for equality with this map.
  Returns:
    `true` if the specified object is equal to this map.

### forEachKey

    public abstract boolean forEachKey(IntProcedure procedure)

  Applies a procedure to each key of the receiver, if any. Note: Iterates over the keys in no particular order. Subclasses can define a particular order, for example, "sorted by key". All methods which can be expressed in terms of this method (most methods can) must guarantee to use the same order defined by this method, even if it is no particular order. This is necessary so that, for example, methods `keys` and `values` will yield association pairs, not two uncorrelated lists.

  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

### forEachPair

    public boolean forEachPair(IntDoubleProcedure procedure)

  Applies a procedure to each (key,value) pair of the receiver, if any. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

### get

    public abstract double get(int key)

  Returns the value associated with the specified key. It is often a good idea to first check with `containsKey(int)` whether the given key has a value associated or not, i.e. whether there exists an association for the given key or not.

  Parameters:
    `key` - the key to be searched for.
  Returns:
    the value associated with the specified key; `0` if no such key is present.

### keyOf

    public int keyOf(double value)

  Returns the first key the given value is associated with. It is often a good idea to first check with `containsValue(double)` whether there exists an association from a key to this value. Search order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  Parameters:
    `value` - the value to search for.
  Returns:
    the first key for which holds `get(key) == value`; returns `Integer.MIN_VALUE` if no such key exists.

### keys

    public IntArrayList keys()

  Returns a list filled with all keys contained in the receiver. The returned list has a size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  This method can be used to iterate over the keys of the receiver.

  Returns:
    the keys.

### keys

    public void keys(IntArrayList list)

  Fills all keys contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  This method can be used to iterate over the keys of the receiver.

  Parameters:
    `list` - the list to be filled, can have any size.

### keysSortedByValue

    public void keysSortedByValue(IntArrayList keyList)

  Fills all keys sorted ascending by their associated value into the specified list. Fills into the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Primary sort criterium is "value", secondary sort criterium is "key". This means that if any two values are equal, the smaller key comes first.

  Example:
  `keys = (8,7,6), values = (1,2,2) --> keyList = (8,6,7)`

  Parameters:
    `keyList` - the list to be filled, can have any size.

### pairsMatching

    public void pairsMatching(IntDoubleProcedure condition,
                              IntArrayList keyList,
                              DoubleArrayList valueList)

  Fills all pairs satisfying a given condition into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size, the number of pairs satisfying the condition. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  Example:

      IntDoubleProcedure condition = new IntDoubleProcedure() { // match even keys only
              public boolean apply(int key, double value) { return key%2==0; }
      }
      keys = (8,7,6), values = (1,2,2) --> keyList = (6,8), valueList = (2,1)

  Parameters:
    `condition` - the condition to be matched. Takes the current key as first and the current value as second argument.
    `keyList` - the list to be filled with keys, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### pairsSortedByKey

    public void pairsSortedByKey(IntArrayList keyList,
                                 DoubleArrayList valueList)

  Fills all keys and values sorted ascending by key into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size that equals `this.size()`.

  Example:
  `keys = (8,7,6), values = (1,2,2) --> keyList = (6,7,8), valueList = (2,2,1)`

  Parameters:
    `keyList` - the list to be filled with keys, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### pairsSortedByValue

    public void pairsSortedByValue(IntArrayList keyList,
                                   DoubleArrayList valueList)

  Fills all keys and values sorted ascending by value into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size that equals `this.size()`. Primary sort criterium is "value", secondary sort criterium is "key". This means that if any two values are equal, the smaller key comes first.

  Example:
  `keys = (8,7,6), values = (1,2,2) --> keyList = (8,6,7), valueList = (1,2,2)`

  Parameters:
    `keyList` - the list to be filled with keys, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### put

    public abstract boolean put(int key,
                                double value)

  Associates the given key with the given value. Replaces any old `(key,someOtherValue)` association, if existing.

  Parameters:
    `key` - the key the value shall be associated with.
    `value` - the value to be associated.
  Returns:
    `true` if the receiver did not already contain such a key; `false` if the receiver did already contain such a key - the new value has now replaced the formerly associated value.

### removeKey

    public abstract boolean removeKey(int key)

  Removes the given key with its associated element from the receiver, if present.

  Parameters:
    `key` - the key to be removed from the receiver.
  Returns:
    `true` if the receiver contained the specified key, `false` otherwise.

### toString

    public String toString()

  Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by key.

### toStringByValue

    public String toStringByValue()

  Returns a string representation of the receiver, containing the String representation of each key-value pair, sorted ascending by value.

### values

    public DoubleArrayList values()

  Returns a list filled with all values contained in the receiver. The returned list has a size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  This method can be used to iterate over the values of the receiver.

  Returns:
    the values.

### values

    public void values(DoubleArrayList list)

  Fills all values contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(IntProcedure)`.

  This method can be used to iterate over the values of the receiver.

  Parameters:
    `list` - the list to be filled, can have any size.

Colt 1.2.0

Jump to the Colt Homepage